Bug 27575 - HDMI audio only works with DIG1 encoder
Summary: HDMI audio only works with DIG1 encoder
Status: RESOLVED INVALID
Alias: None
Product: xorg
Classification: Unclassified
Component: Driver/Radeon (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Egbert Eich
QA Contact: Xorg Project Team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2010-04-10 04:40 UTC by Tomaž Šolc
Modified: 2018-06-12 19:06 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments
Patch to prefer UNIPHYA output for DIG1 encoder. (773 bytes, patch)
2010-04-10 04:40 UTC, Tomaž Šolc
no flags Details | Splinter Review
Xorg.log with unpatched driver (audio not working) (72.45 KB, text/plain)
2010-04-10 04:42 UTC, Tomaž Šolc
no flags Details
Xorg.log with patched driver (audio working) (72.15 KB, text/plain)
2010-04-10 04:42 UTC, Tomaž Šolc
no flags Details
Xorg.log, audio working, KMS with radeon (38.32 KB, text/plain)
2010-04-14 10:44 UTC, Tomaž Šolc
no flags Details
Xorg.log, audio not working, KMS with radeon (41.03 KB, text/plain)
2010-04-14 10:45 UTC, Tomaž Šolc
no flags Details
xorg.conf, audio working (547 bytes, text/plain)
2010-04-14 10:46 UTC, Tomaž Šolc
no flags Details
xorg.conf, audio not working (546 bytes, text/plain)
2010-04-14 10:47 UTC, Tomaž Šolc
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Tomaž Šolc 2010-04-10 04:40:20 UTC
Created attachment 34871 [details] [review]
Patch to prefer UNIPHYA output for DIG1 encoder.

Hi

I have a MSI-made Radeon HD 4350 card with a HDMI, DVI and a VGA connector (log says "Card not in database: 0x954F:0x1462:0x1618"). I have a monitor connected to the DVI output and a TV on the HDMI.

With the radeonhd driver from git HDMI audio only works when the HDMI output is initialized first by the driver (for example, when Option "Primary" is set in the Monitor section for the TV in xorg.conf).

It appears the problem is caused by encoder assignments.

This card has two digital output blocks: UNIPHYA for the HDMI connector and UNIPHYE for the DVI.

Audio only works when the DIG1 encoder is assigned to UNIPHYA. If DIG2 is used there is only silence on the TV. I'm not sure whether this is caused by a bug in the driver or limitation of the hardware.

I've confirmed this hypothesis with a simple patch that prefers UNIPHYA for DIG1 (attached).

My patch is obviously specific to my setup, but I'm prepared to help in finding a proper solution.

Regards
Tomaž
Comment 1 Tomaž Šolc 2010-04-10 04:42:05 UTC
Created attachment 34872 [details]
Xorg.log with unpatched driver (audio not working)
Comment 2 Tomaž Šolc 2010-04-10 04:42:57 UTC
Created attachment 34873 [details]
Xorg.log with patched driver (audio working)
Comment 3 Christian König 2010-04-10 05:00:48 UTC
That's a known bug / limitation of the current implementation for DCE32 cards.

You could switch to KMS, or we could fix the HDMI config register implementation in radeonhd. But i doubt that this really worth the work, because switching to KMS is the real long term solution.
Comment 4 Tomaž Šolc 2010-04-10 05:56:44 UTC
Ok, I guess I'll give KMS and the latest radeon driver a shot. 

I see that audio support for >r700 was added to kernel last month. 

http://kerneltrap.org/mailarchive/git-commits-head/2010/4/1/31365
Comment 5 Rafał Miłecki 2010-04-12 22:06:36 UTC
All code sits in just released 2.6.34-rc4. Can you test it, please?
Comment 6 Tomaž Šolc 2010-04-14 10:42:06 UTC
(In reply to comment #5)
> All code sits in just released 2.6.34-rc4. Can you test it, please?

Interestingly, the original problem is still there with KMS (using kernel 2.6.34-rc4 and latest radeon driver from git).

If I set Option "Primary" on the monitor connected to the DVI output, HDMI audio doesn't work.
Comment 7 Tomaž Šolc 2010-04-14 10:44:15 UTC
Created attachment 35018 [details]
Xorg.log, audio working, KMS with radeon
Comment 8 Tomaž Šolc 2010-04-14 10:45:09 UTC
Created attachment 35020 [details]
Xorg.log, audio not working, KMS with radeon
Comment 9 Tomaž Šolc 2010-04-14 10:46:58 UTC
Created attachment 35021 [details]
xorg.conf, audio working
Comment 10 Tomaž Šolc 2010-04-14 10:47:28 UTC
Created attachment 35022 [details]
xorg.conf, audio not working
Comment 11 Jeremy Huddleston Sequoia 2011-10-16 16:00:05 UTC
Does this issue occur with the preferred ati driver (xf86-vide-ati)?  If so, please move this to the Driver/Radeon component.  

Development of radeonhd has pretty much halted and development focus is on the ati driver.  Please see http://www.x.org/wiki/radeonhd

If the issue does not exist in the ati driver (or if there is no response to this message), this bug will be closed as WONTFIX unless someone contributes a patch.
Comment 12 Tomaž Šolc 2011-10-18 04:18:52 UTC
I'm using the new "radeon" module with KMS now (currently Linux 2.6.34.7, xserver-xorg-video-ati 1:6.13.1-2+squeeze1 as shipped by Debian Squeeze) and there are still problems with HDMI audio I described in comment 6.

I did later found out that when audio isn't working I can get it to work by either power-cycling the TV, or turning on and off the HDMI output via xrandr.

So I'm not sure how encoder selection fits into all of that. It might be a hardware bug on either the graphics card or the TV. But now that I know how to work around it this issue is much less of a problem.

If someone is interested in debugging this I can provide more info. Otherwise feel free to close this bug.
Comment 13 Adam Jackson 2018-06-12 19:06:37 UTC
Mass closure: This bug has been untouched for more than six years, and is not
obviously still valid. Please reopen this bug or file a new report if you continue to experience issues with current releases.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.